//+------------------------------------------------------------------+
//|                             SimpleDailyRangeBreakExpert_v1.0.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>
#include <Tracert.mqh>

//---- input parameters
extern string     Expert_Name = "---- SimpleDailyRangeBreakExpert_v1.0 ----";

extern int        Magic=1007;
extern int        Slippage=6;

extern bool       Trace = false;           // Trace Switch

extern string     Main_Parameters = " Trade Volume & Trade Method";
extern double     Lots = 0.1;
extern bool       TrailingStop = false;     // Trailing Stop Switch   
extern bool       InitialStop  = true;      // Initial Stop Switch

extern string     Data = " Input Data ";
extern double     BuyPercent     = 70;          // 	
extern double     SellPercent    = 70;          // 
extern double     StopPercent    = 50;
extern int        TradePeriod    = 5;

extern string     Trade   =  " Trade Days of Week";
extern bool       Monday       = true;
extern bool       Tuesday      = true;
extern bool       Wednesday    = true;
extern bool       Thursday     = true;
extern bool       Friday       = true;

extern string     MM_Parameters = " MoneyManagement by L.Williams ";
extern bool       MM=false;               //  Switch
extern double     MMRisk=0.15;              // Risk Factor
extern double     LossMax=1000;           // Maximum Loss by 1 Lot


int      cnt=0, ticket, mode=0;
double   high=0,low=0, close=0, open=0, range=0, spread=0, Profit=0;
double   smin=0, smax=0, BuyStop=0, SellStop=0, Lotsi=0;
bool     BuyInTrade=false, SellInTrade=false;
datetime opentime, Previous_day, OrderOpenDay;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
  Previous_day=Day(); 
//----
   return(0);
  }
// ---- Money Management
double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   double Lotsi=Lots;
	    
   if ( flag ) Lotsi=NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
}   

// Closing of Pending Orders      
void PendOrdDel()
{
    int total=OrdersTotal();
    for (int cnt=total-1;cnt>=0;cnt--)
    { 
      OrderSelect(cnt, SELECT_BY_POS,MODE_TRADES);   
      
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic  )     
        {
        int mode=OrderType();
        
        bool result = false;
          switch(mode)
          {
            
            case OP_BUYSTOP   : result = OrderDelete( OrderTicket() ); 
          
            case OP_SELLSTOP  : result = OrderDelete( OrderTicket() ); 
          if(!result)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
          Print(" cnt=",cnt, " total=",total," MODE = ",mode," Ticket=",OrderTicket()  );                       
          }
         }
      } 
  return;
  }    

// 

void CloseOrdbyTime()
{
     int total=OrdersTotal();
     
     for (cnt=0;cnt<total;cnt++)
     { 
        OrderSelect(cnt, SELECT_BY_POS);   
        mode=OrderType();
        if ( TradePeriod>0 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        { 
          datetime OpenTime=StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE)); 
          int CalcBars=TradePeriod;
         
            if ((iTime(NULL,PERIOD_D1,0)-OpenTime)>=PERIOD_D1*CalcBars*60 || OrderProfit()>0)
            {
              if (mode==OP_BUY )
			     OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Yellow);
			     if (mode==OP_SELL)
			     OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White);
            }
        }
    }

}       
 
// ---- 
void TrailStops()
{        
    int total=OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     mode=OrderType();    
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic ) 
        {
            if ( mode==OP_BUY && smin > OrderStopLoss() )
            {
            Profit=0;
			   OrderModify(OrderTicket(),OrderOpenPrice(),smin,Profit,0,LightGreen);
			   return(0);
            }
           if ( mode==OP_SELL && smax < OrderStopLoss())
            {
            Profit=0;
   		   OrderModify(OrderTicket(),OrderOpenPrice(),smax,Profit,0,Yellow);	    
            return(0);
            }    
        }
    }   
} 

void SellOrdOpen()
{		     

		  double SellPrice=open - range*SellPercent/100.0 - spread;
		  
		  if (InitialStop) SellStop=SellPrice + StopPercent*range/100.0; else SellStop=0;
        Profit=0;
	       
		  ticket = OrderSend(Symbol(),OP_SELLSTOP,Lotsi,NormalizeDouble(SellPrice,4),Slippage,SellStop,Profit,"sell",Magic,0,Red);
    
        OrderSelect(ticket, SELECT_BY_TICKET);   
        OrderOpenDay  = StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE));
           
        SellInTrade=false;            
            
            if(ticket<0)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
}

void BuyOrdOpen()
{		     

		  double BuyPrice =open + range*BuyPercent/100.0  + spread;
		  if (InitialStop) BuyStop = BuyPrice - StopPercent*range/100.0; else BuyStop=0;
        Profit=0;
		 
		  ticket = OrderSend(Symbol(),OP_BUYSTOP ,Lotsi,NormalizeDouble(BuyPrice ,4),Slippage,BuyStop ,Profit,"buy",Magic,0,Blue);
                
        OrderSelect(ticket, SELECT_BY_TICKET);   
        OrderOpenDay  = StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE));
     
        BuyInTrade=false;            
            
            if(ticket<0)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
}      

void ExtraOrdDel()
{
    int total = OrdersTotal();
    for (cnt=0;cnt<total;cnt++)
    { 
      OrderSelect(cnt, SELECT_BY_POS);   
      mode=OrderType();
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic )     
        {
            if (mode==OP_BUY  && !BuyInTrade ) BuyInTrade =true;
            if (mode==OP_SELL && !SellInTrade) SellInTrade=true;
            
            if (mode > OP_SELL && (BuyInTrade || SellInTrade)) 
            {
            OrderDelete(OrderTicket());
            }
                        
	     }
	 }        
}  	                    
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
//int deinit()
//  {
//---- 
   
//----
//   return(0);
//  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < 1) {
   Print("Not enough bars for this strategy");
   return(0);
   }
   
   
   //int ticket, sellticket, buyticket;
//---- 
   if ( Trace ) SetTrace();
   if (TrailingStop) InitialStop=true; 
   //opentime = iTime(NULL,PERIOD_D1,0); 
   //datetime begin = StrToTime(TimeToStr(opentime,TIME_DATE)+" "+StartSession);
   //Print (" Begin=", TimeToStr(opentime,TIME_DATE)+" "+StartSession); 
  
 if (Previous_day!=Day()) 
   {  
   high  = iHigh(NULL,PERIOD_D1,1);
   low   = iLow(NULL,PERIOD_D1,1);
   close = iClose(NULL,PERIOD_D1,1);
   open  = iOpen(NULL,PERIOD_D1,0);
   range =(high-low);
   spread= MarketInfo(Symbol(),MODE_SPREAD)*Point;
   
   
     
   Lotsi = MoneyManagement ( MM, Lots, MMRisk, LossMax);

   smin = close - StopPercent*range/100.0;
   smax = close + StopPercent*range/100.0;
   
   PendOrdDel();  
   
   CloseOrdbyTime();
   
   if (TrailingStop) TrailStops(); 
   
   if(OrdersTotal()<1)
   {
   if( Monday    ) if(DayOfWeek()==1){BuyOrdOpen(); SellOrdOpen();}
   if( Tuesday   ) if(DayOfWeek()==2){BuyOrdOpen(); SellOrdOpen();}
   if( Wednesday ) if(DayOfWeek()==3){BuyOrdOpen(); SellOrdOpen();} 
   if( Thursday  ) if(DayOfWeek()==4){BuyOrdOpen(); SellOrdOpen();} 
   if( Friday    ) if(DayOfWeek()==5){BuyOrdOpen(); SellOrdOpen();}
   }
      
   Previous_day=Day();  
   }
   else 
   {
   ExtraOrdDel();
   Previous_day=Day(); 
   }
   
   
 return(0);
}//int start
//+------------------------------------------------------------------+





